entity dct is
	port (i0, i1, i2, i3, i4, i5, i6, i7: in real;
		  o0, o1, o2, o3, o4, o5, o6, o7: out real);
end dct;

architecture dct_behav of dct is
begin
	process(i0, i1, i2, i3, i4, i5, i6, i7)
		variable a0, a1, a2, a3, a4, a5, a6, a7:real;
		variable b0, b1, b2, b3, b4, b5, b6, b7:real;
		variable c0, c1, c2, c3, c4, c5, c6, c7:real;
		variable d0, d1, d2, d3, d4, d5, d6, d7:real;
	begin
		-- stage 1
		a0 := i0 + i7;
		a7 := i0 - i7;
		b1 := i1 + i2;
		a2 := i1 - i2;
		a3 := i3 + i4;
		a4 := i3 - i4;
		b5 := i5 + i6;
		a6 := i5 - i6;

		-- stage 2
		b0 := a0 + a4;
		c4 := a0 - a4;
		d2 := a2 + a6;
		b6 := a2 - a6;
		d3 := a3 + a7;
		c7 := a3 - a7;

		-- stage 3
		d0 := b0 + b1;
		d1 := b0 - b1;
		c5 := b5 * 0.70710678;
		c6 := b6 * 0.70710678;

		-- stage 4
		d4 := c4 + c6;
		d6 := c4 - c6;
		d5 := c5 + c7;
		d7 := c5 - c7;

		-- stage 5
		o4 <= d0 * 0.70710678;
		o0 <= d1 * 0.70710678;
		o2 <= d2 * 0.5 + d3 * 0.4;
		o6 <= d2 * 0.4 - d3 * 0.5;
		o1 <= d4 * 0.5 + d5 * 0.4;
		o7 <= d4 * 0.4 - d5 * 0.5;
		o3 <= d6 * 0.5 + d7 * 0.4;
		o5 <= d6 * 0.4 - d7 * 0.5;
	end process;
end dct_behav;

configuration cfg_dct of dct is
	for dct_behav
	end for;
end cfg_dct;
